UNIT UTST_Frame_in_DLL;
{$mode ObjFPC}{$H+}
INTERFACE
USES
    Classes
  , Sysutils
  , ExtCtrls
  , Forms
  , Graphics
  , controls
  , ComCtrls
  ;


TYPE
  TCL_Frame = CLASS( TObject )
    PRIVATE { Attribute }
      mv_Name  : String;

    PRIVATE { Objecte }
      mo_Frame : TFrame;
      mo_PNL_Top : TPanel;
      mo_PNL_Bot : TPanel;

    PRIVATE { Event-Handler }

    PRIVATE { SET'ter}

    PRIVATE { GET'ter}

    PROTECTED { Functions }
      FUNCTION   sGET_Name : String;
      FUNCTION   boGET_Visible : Boolean;
      PROCEDURE  SET_Visible( iv_Value : Boolean );

    PROTECTED { Procedures }
    PROTECTED { Event-Handler }
    PROTECTED { Property's }

    PUBLIC
      CONSTRUCTOR Create( io_Owner : TComponent; iv_Name : String;  iv_Color : TColor );
      DESTRUCTOR  Destroy;                                                                          OVERRIDE;
    PUBLIC { Functions }
      FUNCTION    ACTIVATE : Boolean;
    PUBLIC { Procedures }

    PUBLIC { Event-Handler }
    PUBLIC { Property's }
      PROPERTY    Visible : Boolean
                  READ  boGET_Visible
                  WRITE SET_Visible;

      PROPERTY    Name : String
                  READ  sGET_Name;
  END;




IMPLEMENTATION


{===================================================================================================
===================================================================================================}
CONSTRUCTOR TCL_Frame.Create( io_Owner : TComponent; iv_Name : String;  iv_Color : TColor );
BEGIN
  INHERITED Create;
  mv_Name         := iv_Name;

  mo_Frame           := TFrame.Create( NIL );
  mo_Frame.Parent    := io_Owner.Owner AS TWinControl;
  mo_Frame.Align     := alClient;
  mo_Frame.Color     := iv_Color;
  mo_Frame.Visible   := False;
  io_Owner.InsertComponent( mo_Frame );

  mo_PNL_Top         := TPanel.Create( mo_Frame );
  mo_PNL_Top.Parent  := mo_Frame;
  mo_PNL_Top.Align   := alTop;
  mo_PNL_Top.Name    := 'PNL_Top';
  mo_PNL_Top.Caption := 'Panel_Top_' + iv_Name;
  mo_PNL_Top.Color   := clDefault;

  mo_PNL_Bot         := TPanel.Create( mo_Frame );
  mo_PNL_Bot.Parent  := mo_Frame;
  mo_PNL_Bot.Align   := alBottom;
  mo_PNL_Bot.Name    := 'PNL_Bot';
  mo_PNL_Bot.Caption := 'Panel_Bottom_'  + iv_Name;
  mo_PNL_Bot.Color   := clDefault;
END;



{===================================================================================================
===================================================================================================}
DESTRUCTOR TCL_Frame.Destroy;
BEGIN
  FreeAndNil( mo_PNL_Bot );
  FreeAndNil( mo_PNL_Top );
  FreeAndNil( mo_Frame );
  INHERITED Destroy;
END;


{===================================================================================================
===================================================================================================}
PROCEDURE TCL_Frame.SET_Visible( iv_Value : Boolean );
BEGIN
  mo_Frame.Visible := iv_Value;
END;


{===================================================================================================
===================================================================================================}
FUNCTION TCL_Frame.boGET_Visible : Boolean;
BEGIN
  Result := mo_Frame.Visible;
END;


{===================================================================================================
===================================================================================================}
FUNCTION TCL_Frame.ACTIVATE : Boolean;
BEGIN
  mo_Frame.Visible := True;
  Result := True;
END;


{===================================================================================================
===================================================================================================}
FUNCTION TCL_Frame.sGET_Name : String;
BEGIN
  Result := mv_Name;
END;



END.

