UNIT UTST_TS_Collector;
{$mode ObjFPC}{$H+}
INTERFACE
USES
    Classes
  , Sysutils
  , Graphics
  , ComCtrls
  , Dialogs
  , UTST_Frame_in_DLL
  ;


TYPE
  TCL_TS_Collector = CLASS( TObject )
    PRIVATE { Attribute }
      mo_Liste : TList;

    PRIVATE { Objecte }

    PRIVATE { Event-Handler }

    PRIVATE { SET'ter}

    PRIVATE { GET'ter}

    PROTECTED { Functions }
    PROTECTED { Procedures }
    PROTECTED { Event-Handler }
    PROTECTED { Property's }

    PUBLIC
      CONSTRUCTOR Create;
      DESTRUCTOR  Destroy;                                                                          OVERRIDE;
    PUBLIC { Functions }
      FUNCTION    ACTIVATE_TabSheet( iv_Name : String ) : Boolean;

    PUBLIC { Procedures }
      PROCEDURE   ADD_TabSheet( io_Owner : TComponent; iv_Name : String; iv_Color : TColor );
      PROCEDURE   DeActivate_TabSheet( iv_Name : String );

    PUBLIC { Event-Handler }
    PUBLIC { Property's }
  END;


VAR
  GO_Obj_List : TCL_TS_Collector;



IMPLEMENTATION


{===================================================================================================
===================================================================================================}
CONSTRUCTOR TCL_TS_Collector.Create;
BEGIN
  INHERITED Create;
  mo_Liste := TList.Create;
END;



{===================================================================================================
===================================================================================================}
DESTRUCTOR TCL_TS_Collector.Destroy;
BEGIN
  FreeAndNil( mo_Liste );
  INHERITED Destroy;
END;


{===================================================================================================
===================================================================================================}
PROCEDURE TCL_TS_Collector.ADD_TabSheet( io_Owner : TComponent; iv_Name : String; iv_Color : TColor );
VAR lv_i : Integer; lo_TS_Obj : TCL_Frame;
BEGIN
  IF Assigned( io_Owner ) THEN BEGIN
    lo_TS_Obj := TCL_Frame.Create( io_Owner, iv_Name, iv_Color );
    mo_Liste.Add( lo_TS_Obj );
    lv_i := mo_Liste.Count;
  END ELSE BEGIN
    ShowMessage( 'Die Funktion: "ADD_TabSheet" konnte nicht geladen werden.' );
  END;
END;


{===================================================================================================
===================================================================================================}
PROCEDURE TCL_TS_Collector.DeActivate_TabSheet( iv_Name : String );
VAR lv_i : Integer; lo_TS_Obj : TCL_Frame;
BEGIN
  FOR lv_i := 0 TO mo_Liste.Count - 1 DO BEGIN
    TCL_Frame( mo_Liste.Items[ lv_i ] ).Visible := False;
  END;
END;




{===================================================================================================
===================================================================================================}
FUNCTION TCL_TS_Collector.ACTIVATE_TabSheet( iv_name : String ) : Boolean;
VAR lo_Frame : TCL_Frame; lv_i : Integer;
BEGIN
  DeActivate_TabSheet( '' );
  FOR lv_i := 0 TO mo_Liste.Count - 1 DO BEGIN
    lo_Frame := TCL_Frame( mo_Liste.Items[ lv_i ] );
    IF lo_Frame.Name = iv_Name THEN BEGIN
      Result := lo_Frame.ACTIVATE;
      EXIT;
    END;
  END;
END;





INITIALIZATION
  GO_Obj_List := TCL_TS_Collector.Create;


FINALIZATION
  FreeAndNil( GO_Obj_List );


END.

